package com.izouma.wenlvju.web;

import com.izouma.wenlvju.domain.ArtType;
import com.izouma.wenlvju.dto.PageQuery;
import com.izouma.wenlvju.exception.BusinessException;
import com.izouma.wenlvju.repo.ArtTypeRepo;
import com.izouma.wenlvju.service.ArtTypeService;
import com.izouma.wenlvju.utils.ObjUtils;
import com.izouma.wenlvju.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/artType")
@AllArgsConstructor
public class ArtTypeController extends BaseController {
    private ArtTypeService artTypeService;
    private ArtTypeRepo    artTypeRepo;

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public ArtType save(@RequestBody ArtType record) {
        if (record.getId() != null) {
            ArtType orig = artTypeRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return artTypeRepo.save(orig);
        }
        return artTypeRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<ArtType> all(@RequestBody PageQuery pageQuery) {
        return artTypeService.all(pageQuery);
    }

    @PostMapping("/allList")
    public List<ArtType> allList() {
        return artTypeService.getTree(artTypeRepo.findAll());
    }

    @GetMapping("/get/{id}")
    public ArtType get(@PathVariable Long id) {
        return artTypeRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        artTypeRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<ArtType> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }

    @PostMapping("/parent")
    public List<ArtType> parent() {
        return artTypeRepo.findAllByParentIsNull();
    }
}

